image: python:3.6.6

stages:
- test
- deploy

# Unit-test the utility (except when being tagged)
unittest:
  stage: test
  tags:
  - docker
  script:
  - pip install -r requirements.txt
  - pip install -r build-requirements.txt
  - flake8
  - pyroma -d .
  # Unset the CI_COMMIT_TAG
  # as it upsets the tests based on it...
  - unset CI_COMMIT_TAG
  - python setup.py test
  - pytest --cov=guesstag
  artifacts:
    paths:
    - htmlcov
    expire_in: 1 week

# Publish the tagged version to PyPi (when tagged).
# We expect the following environment variables: -
#   TWINE_USERNAME
#   TWINE_PASSWORD
deploy:
  stage: deploy
  tags:
  - docker
  script:
  - pip install -r package-requirements.txt
  - pip install -r requirements.txt
  - python setup.py bdist_wheel
  - twine upload dist/*
  dependencies:
  - unittest
  only:
  - tags
